#include <windows.h>

#include <dinput.h>

#include <stdio.h>
#include <stdlib.h>

struct key_entry_t {
	const char *	name;
	unsigned int	address;
	unsigned int	orig_address;
	unsigned int	key;
};

// v1.04

struct key_entry_t key_table[] = {
	{ "KeyUp",	0x5669,		0x5669,		DIK_UP		},
	{ "KeyDown",	0x567a,		0x567a,		DIK_DOWN	},
	{ "KeyLeft",	0x568b,		0x568b,		DIK_LEFT	},
	{ "KeyRight",	0x569c,		0x569c,		DIK_RIGHT	},
	{ "KeyA",	0x56ad,		0x56ad,		DIK_Z		},
	{ "KeyB",	0x56be,		0x56be,		DIK_X		},
	{ "KeyC",	0x56cf,		0x56cf,		DIK_C		},
	{ "KeyTouch",	0x56e0,		0x56e0,		DIK_S		},
	{ "KeyAppeal",	0x56f1,		0x56f1,		DIK_LSHIFT	},
	{ "KeyUnknown1",0x56ff,		0x56ff,		DIK_A		},
	{ "KeyUnknown2",0x5710,		0x5710,		DIK_D		},
	{ "KeyUnknown3",0x5721,		0x5721,		DIK_Q		},
	{ "KeyUnknown4",0x5732,		0x5732,		DIK_E		},
	{ "KeyStart",	0x5743,		0x5743,		DIK_W		},
	{ "KeyUnknown5",0x5754,		0x5754,		DIK_RETURN	},
	{ "KeyUnknown6",0x60e95,	0x5765,		DIK_RSHIFT	},
	{ "KeyAB",	0x60e62,	0x0,		0		},
	{ "KeyBC",	0x60e73,	0x0,		0		},
	{ "KeyABC",	0x60e84,	0x0,		0		},
};

const unsigned char code_1[7] = {
	// JMP 461a60
	0xe9, 0xf8, 0xb6, 0x05, 0x00, 0x90, 0x90
};
const unsigned int code_1_size = sizeof(code_1);
const unsigned int code_1_address = 0x5763;

const unsigned char code_2[] = {
	// 461a60
	// CMP BYTE PTR SS:[EBP+xx], 0
	0x80, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00,
	// JE SHORT blahblah
	0x74, 0x08,
	// OR DWORD PTR SS:[ESP+14], 20 (AB)
	0x81, 0x4c, 0x24, 0x14, 0x20, 0x00, 0x00, 0x00,
	
	// 461a71
	// again, BC (0x40)
	0x80, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x74, 0x08,
	0x81, 0x4c, 0x24, 0x14, 0x40, 0x00, 0x00, 0x00,
	
	// 461a82
	// again, ABC (0x80)
	0x80, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x74, 0x08,
	0x81, 0x4c, 0x24, 0x14, 0x80, 0x00, 0x00, 0x00,
	
	// 461a93
	// CMP BYTE PTR SS:[EBP+75A], 0
	0x80, 0xbd, 0x5a, 0x07, 0x00, 0x00, 0x00,
	
	// 461a9a
	// JMP 40636a
	0xe9, 0xcb, 0x48, 0xfa, 0xff
};
const unsigned int code_2_size = sizeof(code_2);

const unsigned int code_2_address = 0x60e60;	// 461a60

int key_table_size = sizeof(key_table)/sizeof(key_table[0]);

void run() {
	FILE *file = fopen("GameMain.exe", "rb");
	unsigned char *data;
	unsigned int size;
	int i;
	
	if (!file) {
		printf("Could not open GameMain.exe\n");
		
		return;
	}
	
	fseek(file, 0, SEEK_END);
	size = ftell(file);
	fseek(file, 0, SEEK_SET);
	
	if (size < 0xb0000) {
		printf("Not a valid executable.\n");
		
		return;
	}
	
	data = malloc(size);
	fread(data, size, 1, file);
	
	fclose(file);
	
	/* verify that it is valid. */
	if (memcmp(data + 0x64796, " v1.04", 6) != 0) {
		printf("This version of kbrebind only works with v1.04.\n");
		
		free(data);
		return;
	}
	
	/* get all original keys */
	for (i = 0; i < key_table_size; ++i) {
		if (key_table[i].orig_address == 0) {
			continue;
		}
		
		key_table[i].key = *(unsigned int *)(data + key_table[i].orig_address) - 0x71c;
	}
	
	/* write new keybind code */
	memcpy(data + code_1_address, code_1, code_1_size);
	memcpy(data + code_2_address, code_2, code_2_size);
	
	/* update binds */
	for (i = 0; i < key_table_size; ++i) {
		unsigned int orig;
		if (key_table[i].address == 0) {
			continue;
		}
		
		orig = key_table[i].key;
		
		key_table[i].key = GetPrivateProfileInt("KEYS", key_table[i].name, key_table[i].key, "./kbrebind.ini");
		
		*(unsigned int *)(data + key_table[i].address) = key_table[i].key + 0x71c;
		printf("%20s: %8x -> %8x\n", key_table[i].name, orig, *(unsigned int *)(data + key_table[i].address) - (0x71c));
	}
	
	file = fopen("GameMain-kb.exe", "wb");
	if (file) {
		fwrite(data, size, 1, file);
		fclose(file);
	}
	
	printf("done! GameMain-kb.exe created\n");
}

int main() {
	run();
	
	printf("press enter to close.\n");
	getchar();
	
	return 0;
}
